/*
///////////////////////////////////////////////////////////
Name:	Data Regression
Version:	1.0
Data:	November(11), 25, 2000
Purpose:	Finds regressions of data for linear, 
		exponetial, and variation functions
Note:	This program is mostly written is basic.
		I was planning to use full C, but that proved
		to be a little difficult and complicated.  I kept
		it in a C file because it gave me more control.
///////////////////////////////////////////////////////////
*/


#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files

int _ti89;                    // Produce .89Z File

// Main Function
void _main(void)
{	

TRY		//Full Program Error Recovery 
		//Quits to Home Screen - see ONERR and ENDTRY at end of program
	
	//local variables
	int ii=0;
	int yy=16;
	int run=1;



ClrScr();
FontSetSys(F_4x6);		//Set ASM Font Size

//Main Title
DrawStr(47,0,"Data Regressions",A_NORMAL);
DrawStr(45,8,"Ver. 1.0 - 12.04.00",A_NORMAL);
DrawLine(0,14,LCD_WIDTH,14,A_NORMAL);

//Displays Status of Program
DrawStr(0,yy,"Initializing Variables",A_NORMAL);

//Basic Command, see the basic(string) function on the bottom of the program
//Sorry, can't comment within basic lines

//try checks if the file datareg2 is on the calculator, datareg2 is actually the file
//FolderInfo, released by  "Zeljko Juric and Sebastian Reichelt"

TRY
basic("DelVar regcoef:
Define foldlst=datareg2():
Define sizef=Dim(foldlst):
Define templst=newList(1):  
Define ii=1:
Define kk=1:
Define jj=1:
Define datastr=char(68)&char(65)&char(84)&char(65)");
ONERR
basic("Dialog:
Title \"Error\":
Text \"File datareg2 not found!\":
text \"\":
Text \"Make sure to send both files\":
Text \"datareg and datareg2.\":
EndDlog");
ENDTRY
//Datastr becomes capitol "DATA"

yy+=6;
DrawStr(0,yy,"Finding Data Variables",A_NORMAL);
//Searches all folders for type DATA files
basic("For kk,1,sizef,1:
Define curfold=foldlst[kk]:
Define files=datareg2(curfold):
Define size=Dim(files):
For ii,1,size,1:
Define file=files[ii]:
Define type=expr(\"getType(\"&curfold&\"\\\"&file&\")\"): 
If datastr=type Then:
If curfold=\"main\" Then:
Define templst[jj]=files[ii]:
Else:
Define templst[jj]=curfold&\"\\\"&files[ii]:
EndIf:
Define jj=jj+1:
EndIf:
EndFor:
EndFor:
DelVar files,file,type,datastr,size,curfold,foldlst,kk,sizef");



basic("Define xval=\"1\":
Define yval=\"2\":
Define chfile=1:
Define lenx=0:
Define leny=0");
yy+=6;
DrawStr(0,yy,"Making File List",A_NORMAL);

//First Dialog Box to choose file and columns (c1,c2,...)
TRY
basic("Define ch2=1:
Dialog:
Title \"Data  Setup\":
Text \"\":
DropDown \"Data Variable\",templst,chfile:
Text \"\":
Text \"\":
DropDown \"X is in: \",{\"c1\",\"c2\",\"c3\",\"c4\",\"c5\",\"c6\",\"c7\",\"c8\",\"c9\"},xval:
DropDown \"Y is in: \",{\"c2\",\"c1\",\"c3\",\"c4\",\"c5\",\"c6\",\"c7\",\"c8\",\"c9\"},yval:
EndDlog:
If yval=1 Then:
Define yval=2:
ElseIf yval=2 Then:
Define yval=1:
EndIf:
Define xval=string(xval):
Define yval=string(yval):
Define fname=templst[chfile]:
Define dfile=fname:
DelVar templst,chfile,jj,num,fname");
ONERR	//If no file was found!!!
run=0;
basic("Dialog:
Title \"Error\":
Text \"No data file found in any folder\":
Text \"\":
Text \"\":
EndDlog");
ENDTRY


//If the file was found, continue with the program
if(run==1)
{
	

FontSetSys(F_4x6);	//make the font again 4x6 incase it 
				//changed while going back and forth to basic
yy+=6;
DrawStr(0,yy,"Accessing File",A_NORMAL);



TRY	//Error Capture  - See ONERR below

yy+=6;
DrawStr(0,yy,"Checking Data Dimensions",A_NORMAL);
basic("expr(\"Define fd1=\"&dfile&\"[\"&xval&\"]\"):
expr(\"Define fd2=\"&dfile&\"[\"&yval&\"]\"):
Define lenx=dim(fd1):
Define leny=dim(fd2):
If lenxleny:
Then:
Dialog:
Title \"Error\":
Text \"Num of elements in c\"&xval&\"c\"&yval:
Text \"Check the \"&dfile&\" data file\":
Text \"\":
EndDlog:
Stop:
EndIf:
If lenx=1 or leny=1:
Then:
Dialog:
Title \"Error\":
Text \"Only 1 element in c\"&xval&\" or c\"&yval:
Text \"Check the \"&dfile&\" data file\":
Text \"\":
EndDlog:
Stop:
EndIf:
Define fdlst1=fd1:
Define fdlst2=fd2:
Define fdlst3=log(fdlst1):
Define fdlst4=log(fdlst2):
DelVar lenx,leny,xval,yval");
yy+=6;
DrawStr(0,yy,"Finding Data Regressions",A_NORMAL);

//Find the regressions 
//each regression is in a list, a is [1] , b is [2], and corr is [3]
basic("Define lreg=newList(3):
Define ereg=newList(3):
Define preg=newList(3):
LinReg fdlst1,fdlst2:
Define lreg[1]=string(regcoef[1]):
Define lreg[2]=string(regcoef[2]):
Define lreg[3]=string(corr)");

basic("LinReg fdlst1,fdlst4:
Define ereg[1]=string(10^regcoef[2]):
Define ereg[2]=string(10^regcoef[1]):
Define ereg[3]=string(corr):
LinReg fdlst3,fdlst4:
Define preg[2]=string(regcoef[1]):
Define preg[1]=string(10^regcoef[2]):
Define preg[3]=string(corr):
DelVar fd1,fd2");

//to find the best fitting line(corr closest to +-1), first find absolute diffrence 
//from 1
basic("Define dcl=1-abs(expr(lreg[3])):
Define dce=1-abs(expr(ereg[3])):
Define dcp=1-abs(expr(preg[3])):
Define bflst=newList(3)");

//find best fit, then make the string beqstd(best fit equation standard), and assign the list
//bflst the list of appropriate regressions 
yy+=6;
DrawStr(0,yy,"Finding Best Fit",A_NORMAL);
//First if statement is to check if linear corr is 1, if it is skip other tests 
//In that case var reg would also be 1 b/c it would be yy = 1x^1
basic("If dcl=0 Then:
Define bfit=\"Linear\":
Define beqstd=\"y=ax+b\":
Define bflst=lreg:
Else:
If dcl<dce Then:
If dcl<dcp Then:
Define bfit=\"Linear\":
Define beqstd=\"y=ax+b\":
Define bflst=lreg:
Else:
Define bfit=\"Variation(Power)\":
Define beqstd=\"y=a\"&char(183)&\"x^b\":
Define bflst=preg:
EndIf:
Else:
If dce<dcp Then:
Define bfit=\"Exponential\":
Define beqstd=\"y=a\"&char(183)&\"b^x\":
Define bflst=ereg:
Else:
Define bfit=\"Variation(Power)\":
Define beqstd=\"y=a\"&char(183)&\"x^b\":
Define bflst=preg:
EndIf:
EndIf:
EndIf:
DelVar dce,dcl,dcp");

//Display correlation dialog
basic("Define ch1=0:
Define ch3=0:
Define ch4=0:
Dialog:
Title \"Correlations\":
Text \"Best Fit: \"&bfit:
Text \"\":
Text \"Linear           r=\"&lreg[3]:
Text \"Exponential  r=\"&ereg[3]:
Text \"Variation      r=\"&preg[3]:
Text \"\":
DropDown \"View:\",{\"Best Fit Equation\",\"Graph Best Fit\",\"All Equations\",\"Quit\"},ch1:
EndDlog");


//If the user chose BEST FIT EQUATION, display dialog
basic("If ch1=1 Then:
Dialog:
Title \"Best Fit Equation\":
Text bfit&\" - \"&beqstd:
Text \"\":
Text \"a           =\"&bflst[1]:
Text \"b           =\"&bflst[2]:
Text \"\":
Text \"corr     =\"&bflst[3]:
DropDown \"View: \",{\"Graph of Best Fit\",\"All Equations\",\"Quit\"},ch3:
EndDlog:
EndIf:
DelVar beqstd,bflst");


//If the user chose GRAPH of B.F., display dialog
basic("If ch1=2 or ch3=1 Then:
If bfit=\"Exponential\" Then:
ExpReg fdlst1,fdlst2:
ElseIf bfit=\"Variation(Power)\" Then:
PowerReg fdlst1,fdlst2:
Else:
LinReg fdlst1,fdlst2:
EndIf:
Define y1(x)=regeq(x):
PlotsOff:
NewPlot 1,1,fdlst1,fdlst2:
ZoomData:
DispG:
Pause:
DispHome:
Dialog:
Title \"Next Action\":
Text \"\":
DropDown \"View: \",{\"All Equations\",\"Quit\"},ch4:
Text \"\":
EndDlog:
EndIf");



//If the user chose ALL EQ., display dialog
basic("If ch1=3 or ch3=2 or ch4=1 Then:
Dialog:
Title \"Lin, Exp, and Var Equations\":
Text \"Best Fit: \"&bfit:
Text char(17)&\"Linear - y=ax+b\"&char(18):
Text \"   a = \"&lreg[1]&\"      b = \"&lreg[2]:
Text \"   corr = \"&lreg[3]:
Text char(17)&\"Exponential - \"&\"y=a\"&char(183)&\"b^x\"&char(18):
Text \"   a = \"&ereg[1]&\"      b = \"&ereg[2]:
Text \"   corr = \"&ereg[3]:
Text char(17)&\"Variation - \"&\"y=a\"&char(183)&\"x^b\"&char(18):
Text \"   a = \"&preg[1]&\"      b = \"&preg[2]:
Text \"   corr = \"&preg[3]:
EndDlog:
EndIf");




ONERR		//If an error occurs, safely quit
for(ii=0;ii<100;ii++)
	DrawStr(0,85,"Error. Quiting...",A_REVERSE);
ENDTRY

}
//Delete variables that ere used in the program
basic("DelVar templst,ch2,ch3,ch4,corre,corrl,corrp,beqstd,bfit,ch1,dfile,ii,lenx,leny,xval,yval,jj,chfile:
DelVar fd1,fd2,fdlst3,fdlst4,preg,ereg,lreg");


GKeyFlush();		//Empty the keyboard queue, so nothing is written in the home sceen after it quiits

ONERR	
ENDTRY	//End Full Program Error Recovery

}

//End main program




//Function that makes a basic TI 89 command 
//Example:  Define x=1:Define yy=x+1
void basic(char *string)
{
	HANDLE handle;
	push_parse_text (string);
	handle = HS_popEStack ();
	NG_execute (handle, 0);
	HeapFree (handle);
}


//End of File
